        list    p=16C84
;*******************************************************************
;                           limit.ASM
;                   
;*******************************************************************
;
;
portb   equ     06      ; I/O register F6
porta   equ     05      ; I/o register F5
;
STATUS  set     0x03
CARRY   set     0x00
Same    set     0x01
Wreg    set     0x00
;
; INPUTs
; ON PORT B
_DRV_DCX set    1     ; bit 1           ; High = disable
_STR_DCX set    2     ; bit 2           ; High = disable
_LIMIT  set     3     ; bit 3           ; Active high
_MSbar  set     4     ; bit 4           ; Active LOW
_ESTOP  set     5     ; bit 5           ; Active high
;
; OUTPUTS ON PORT A
_STR    set     0     ; bit 0           ; Active high
_DRV    set     1     ; bit 1           ; Active high
;
;
;********************************************************************
;               Test Program
;*********************************************************************
        org     0x000
        goto    start

        org     0x005

start   clrw
        option
        clrf    portb           ; Clear ports B
        movlw   (1<<_STR) | (1<<_DRV) ; Set these bits on port A
        movwf   porta

                                ; NOTE: MOVED THIS INTO LOOP FOR QUICK FIX
                                ;       SOME BITS WERE SOMEHOW RESET
main    movlw   ((1<<_STR) | (1<<_DRV)) ^ 0xFF ; Sets these bits to outputs
        TRIS    porta
        movlw   0x3F            ; sets bit 0-5 to inputs            
        TRIS    portb

        btfss   portb,_MSbar       ; disable _STR and _DRV if _MSbar && ESTOP
        goto    continueTest
        btfss   portb,_ESTOP
        goto    continueTest
        bcf     porta,_STR
        bcf     porta,_DRV
        goto    main

continueTest
        btfsc   portb,_LIMIT    ; enable _STR iff !LIMIT && !STR_DCX
        goto    disableSTR
        btfsc   portb,_STR_DCX
        goto    disableSTR
enableSTR
        bsf     porta,_STR
        goto    testDRV
disableSTR
        bcf     porta,_STR

testDRV btfsc   portb,_DRV_DCX  ; enable _DRV iff !DRV_DCX
        goto    disableDRV
enableDRV
        bsf     porta,_DRV
        goto    main
disableDRV
        bcf     porta,_DRV
        goto    main

     END


